<!-- /resources/js/components/Leaderboard.vue -->
<template>
    <table class="table table-striped">
        <thead>
        <tr>
            <th>Rank</th>
            <th>Name</th>
            <th>Score</th>
        </tr>
        </thead>
        <tbody>
        <tr :class="{success: page.id == current}" v-for="(page, key) in pageUsers">
            <td>{{ ++key }}</td>
            <td>{{ page.url }}</td>
            <td>{{ page.isCrawled }}</td>
        </tr>
        </tbody>
    </table>
</template>

<script>
    export default {
        props: ['current'],
        data() {
            return {
                pages: []
            }
        },
        created() {
            this.fetchLeaderboard();
            this.listenForChanges();
        },
        methods: {
            fetchLeaderboard() {
                axios.get('leaderboard').then((response) => {
                    this.pages = response.data;
                })
            },
            listenForChanges() {
                Echo.channel('leaderboard')
                .listen('UrlUpdated', (e) => {
                    var page = this.pages.find((page) => page.id === e.id);
                        // check if pages exists on leaderboard
                        if(page){
                            var index = this.pages.indexOf(page);
                            this.pages[index].isCrawled = e.isCrawled;
                        }
                        // if not, add 'em
                        else {
                            this.pages.push(e)
                        } 
                    })
            }
        },
        computed: {
            pageUsers() {
                return this.pages.sort((a,b) => b.score - a.score)
            }
        }
    }
</script>